/* -------------------------------------------------------------- */
/*  LAST EDIT: Sat Aug 17 18:44:21 1996 by Adabas D Database (gutamil.v12-berlin.de!adabas)  */
/*  $Id: AdabasPacket.h,v 1.23 1996/08/17 16:44:27 adabas Exp $ */
/* -------------------------------------------------------------- */
/* Copyright (c) 1996 Christian Krone. All rights reserved.       */
/* This program is free software; you can redistribute it and/or  */
/* modify it under the same terms as Tcl itself.                  */
/* See also licence.terms                                         */
/* -------------------------------------------------------------- */

/* ----------------- Constant definitions------------------------ */
/*
 * Flag parameter of getData.
 */
#define FOR_LONG_OP 1
#define MASS_CMD    2
#define UTILITY_CMD 4

/* ----------------- Type definitions --------------------------- */
typedef struct {
  char application[3];
  int  messType;
  int  withInfo;
#if ADABAS_VERSION >= 62
  int  producer;
#endif
  int  sqlMode;
  int  massCmd;
  int  commitImmediately;
  int  swapKind;
} AdabasPacketInfo;

/* ----------------- Exported procedure headings ---------------- */

extern void AdabasPacketInit _ANSI_ARGS_((AdabasPacketInfo *vars));

extern int scanMessType _ANSI_ARGS_((Tcl_Interp *interp, char *arg));
extern int scanDataType _ANSI_ARGS_((Tcl_Interp *interp, char *arg));
#if ADABAS_VERSION >= 62
extern int scanProducer _ANSI_ARGS_((Tcl_Interp *interp, char *arg));
#endif
extern int scanSqlMode _ANSI_ARGS_((Tcl_Interp *interp, char *arg,
				    int external));
extern char *scanApplication _ANSI_ARGS_((Tcl_Interp *interp, char *arg));
extern service scanService _ANSI_ARGS_((Tcl_Interp *interp, char *arg));
extern char *dataType2String _ANSI_ARGS_((int data_type));
extern char *messType2String _ANSI_ARGS_((int messType));
#if ADABAS_VERSION >= 62
extern char *producer2String _ANSI_ARGS_((int producer));
#endif
extern char *sqlMode2String _ANSI_ARGS_((int sqlMode, int external));
extern char *application2String _ANSI_ARGS_((char *application));
extern char *service2String _ANSI_ARGS_((int serv));

#if ADABAS_VERSION >= 62
extern int getResultCount _ANSI_ARGS_((segment *retSegment));
extern void putResultPart _ANSI_ARGS_((Tcl_Interp *interp, part *ret_part,
				       int4 *part_length));
extern int getShortInfos _ANSI_ARGS_((segment *retSegment,
				      field_info **shortInfos));
extern int getColumnNames _ANSI_ARGS_((segment *retSegment,
				       char **columnNames));
extern int getResultTable _ANSI_ARGS_((segment *retSegment,
				       char *resultTable));
extern int getParsId _ANSI_ARGS_((segment *retSegment,
				  Tcl_DString *parsIdDString));
extern char *getData _ANSI_ARGS_((segment *retSegment, int4 *dataLength,
				  int *argCount, int flags));
extern char *getLongdesc _ANSI_ARGS_((segment *retSegment));
extern int datatypeIsLong _ANSI_ARGS_((int dataType));

#else /* ADABAS_VERSION <= 61 */
extern int  getResultCount _ANSI_ARGS_((packet *retSegment));
extern void putResultPart _ANSI_ARGS_((Tcl_Interp *interp, int partNo,
				       int2 *currPos, packet *retSegment,
				       int sndMessType));
extern int getShortInfos _ANSI_ARGS_((packet *retSegment,
				      field_info **shortInfos));
extern int getResultTable _ANSI_ARGS_((packet *retSegment, char *resultTable));
extern int getParsId _ANSI_ARGS_((packet *retSegment,
				  Tcl_DString *parsIdDString));
extern char *getData _ANSI_ARGS_((packet *retSegment, int4 *dataLength,
				  int *argCount, int flags));
extern char *getLongdesc _ANSI_ARGS_((packet *retSegment, int withArgCount));
extern int datatypeIsLong _ANSI_ARGS_((int dataType));
#endif
