/* -------------------------------------------------------------- */
/*  LAST EDIT: Sat Aug 17 18:45:03 1996 by Adabas D Database (gutamil.v12-berlin.de!adabas)  */
/* $Id: AdabasRte.h,v 1.20 1996/08/17 16:45:10 adabas Exp $ */
/* -------------------------------------------------------------- */
/* Copyright (c) 1996 Christian Krone. All rights reserved.       */
/* This program is free software; you can redistribute it and/or  */
/* modify it under the same terms as Tcl itself.                  */
/* See also licence.terms                                         */
/* -------------------------------------------------------------- */

/* ----------------- Type definitions --------------------------- */
typedef struct {
  nodeid  dbnode;
  dbname  dbname;
  boolean cancel;
  service service;
  int4    reference;
  int4    sqlPacketSize;
#if ADABAS_VERSION >= 62
  /*
   * In pre 6.2 the application is responsible for the allocation of
   * the packet. But now we have to remember the packet...
   */
  void *sqlPacketList[1];
#endif
} AdabasRteInfo;

/* ----------------- Exported procedure headings ---------------- */
extern void AdabasRteInit _ANSI_ARGS_((AdabasRteInfo *vars));
extern int AdabasRteConnect _ANSI_ARGS_((Tcl_Interp *interp,
					 AdabasRteInfo *vars, char *serverdb,
					 int serv));
#if ADABAS_VERSION >= 62
extern int AdabasRteSend _ANSI_ARGS_((Tcl_Interp *interp, AdabasRteInfo *vars,
				      packet *snd_packet,packet **rcv_packet));
#else /* ADABAS_VERSION <= 61 */
extern int AdabasRteSend _ANSI_ARGS_((Tcl_Interp *interp, AdabasRteInfo *vars,
				      packet *snd_packet));
#endif
extern void AdabasRteClose _ANSI_ARGS_((AdabasRteInfo *vars));
extern void AdabasRteCancel _ANSI_ARGS_((AdabasRteInfo *vars));
extern void AdabasRteTermId _ANSI_ARGS_((char *result));
extern void AdabasRteVersion _ANSI_ARGS_((char *rteVersion));
extern int AdabasXUserClear _ANSI_ARGS_((Tcl_Interp *interp));
extern int AdabasXUserOpen _ANSI_ARGS_((Tcl_Interp *interp));
extern int AdabasXUserClose _ANSI_ARGS_((Tcl_Interp *interp));
extern int AdabasXUserIndex _ANSI_ARGS_((Tcl_Interp *interp, int userIndex,
					 xuser_record *userParams));
extern int AdabasXUserGet _ANSI_ARGS_((Tcl_Interp *interp, char *userKey,
				       xuser_record *user_params));
extern int AdabasXUserPut _ANSI_ARGS_((Tcl_Interp *interp,
				       xuser_record *user_params));
extern int AdabasXUserArgs _ANSI_ARGS_((Tcl_Interp *interp,
					xuser_record *userParams,
					char *givenPasswd));
