/* -------------------------------------------------------------- */
/*  LAST EDIT: Sat Aug 17 18:45:21 1996 by Adabas D Database (gutamil.v12-berlin.de!adabas)  */
/*  $Id: AdabasSend.h,v 1.13 1996/08/17 16:45:27 adabas Exp $ */
/* -------------------------------------------------------------- */
/* Copyright (c) 1996 Christian Krone. All rights reserved.       */
/* This program is free software; you can redistribute it and/or  */
/* modify it under the same terms as Tcl itself.                  */
/* See also licence.terms                                         */
/* -------------------------------------------------------------- */

/* ----------------- Constant definitions ----------------------- */
#define ADABAS_MESSAGES     "adamsg"
#define ADABAS_TCL_VERSION  0.4

/* ----------------- Type definitions --------------------------- */

  /*
   * In pre-6.2 we have no part kinds, so here we have to define our
   * own enumeration type. Of cource we only define the kinds, we
   * actually use. And since we try to make life easy, we define
   * this enum for 6.2, too...
   */
#define PART_KINDS 6
typedef enum {
  pkNil,
  pkCommand,
  pkData,
  pkResultcount,
  pkLongdata,
  pkParsid
} partKind;

typedef struct {
  char *buf;
  int4  bufLength;
  int   subst;
} AdabasPartInfo;

/*
 * Note, that it is important to put the array of records at the top,
 * since else the compiler on an HP-UX generated code, that accesses
 * the wrong entries.
 */
typedef struct {
  AdabasPartInfo   partInfos[PART_KINDS];
  AdabasRteInfo    rteInfo;
  AdabasPacketInfo packetInfo;
#if ADABAS_VERSION >= 62
  /*
   * In 6.2 the packet is allocated by the rte, so all we have to do here
   * is remember the address of it and the (always changing) address of
   * the return packet...
   */
  packet *sndPacket;
  packet *rcvPacket;
#else /* ADABAS_VERSION <= 61 */
  /*
   * In pre-6.2 we have to declare the space for the packet ourself.
   * This is exactly the right (and the only one) place for this...
   */
  packet sqlPacket;
#endif
} AdabasInfo;

/* ----------------- Makro definitions -------------------------- */
#define SET_VERSION(result)					\
sprintf (result, "AdabasTcl %.1f (for Adabas D %01d.%01d)",	\
	 ADABAS_TCL_VERSION, ADABAS_VERSION/10, ADABAS_VERSION%10)

/* ----------------- Exported procedure headings ---------------- */
extern int AdabasCloseCmd _ANSI_ARGS_((Tcl_Interp *interp, char *cmdName,
				       AdabasInfo *vars));
extern int AdabasSendCmd _ANSI_ARGS_((ClientData clientData,
				      Tcl_Interp *interp,
				      int argc, char **argv));
extern int AdabasFillPacket _ANSI_ARGS_((Tcl_Interp *interp,
					 AdabasInfo *vars,
					 AdabasPacketInfo *thisOptions));
extern int AdabasSendPacket _ANSI_ARGS_((Tcl_Interp *interp,
					 AdabasInfo *vars));
extern int AdabasSend2PartPacket _ANSI_ARGS_((Tcl_Interp *interp,
					      AdabasInfo *vars,
					      int part1Kind, char *part1,
					      int part1Int, int part2Kind,
					      char *part2, int part2Int));
extern int AdabasSendCmdPacket _ANSI_ARGS_((Tcl_Interp *interp,
					    AdabasInfo *vars, int withInfo,
					    int massCnt, char *command));
extern int AdabasSendValPacket _ANSI_ARGS_((Tcl_Interp *interp,
					    AdabasInfo *vars,
					    int wantedMessType,
					    long_descriptor *longDesc));
