/* ----------------------------------------------------------------- */
/*  LAST EDIT: Sat Aug 17 18:51:36 1996 by Adabas D Database (gutamil.v12-berlin.de!adabas)  */
/*  $Id: sqlrte.h,v 1.14 1996/08/17 16:51:42 adabas Exp $ */
/* ----------------------------------------------------------------- */
/* Copyright (c) 1996 Christian Krone. All rights reserved.          */
/* This program is free software; you can redistribute it and/or     */
/* modify it under the same terms as Tcl itself.                     */
/* See also licence.terms                                            */
/* ----------------------------------------------------------------- */

/* ----------------- variables  of ptoc.h -------------------------- */
extern int _argc;
extern int *_argv;

/* ----------------- types      of libsqlrte.a --------------------- */
typedef          char SQL_PASSWORD[18];
typedef unsigned char xuser_set[2];

/* ----------------- variables  of libsqlrte.a --------------------- */
extern c40 SQLRTEVERSION;

/* ----------------- procedures of libsqlrte.a --------------------- */

extern void sqlinit (c64      component,
		     boolean *canceladdr);

extern void sqlaconnect (int4        pid,
			 nodeid      servernode,
			 dbname      serverdb,
			 service     service,
#if ADABAS_VERSION >= 62
			 int4        packet_cnt,
#endif
			 int4       *reference,
#if ADABAS_VERSION >= 62
			 int4       *sql_packet_size,
			 void       *sql_packet_list[],
#endif
			 errtext     errtext,
			 comm_error *returncode);

extern void sqlarequest (int4        reference,
#if ADABAS_VERSION >= 62
			 void       *sql_packet_ptr,
			 int4        sql_packet_length,
#else
			 packet     *sql_packet,
			 int2        length,
#endif
			 errtext     errtext,
			 comm_error *returncode);

extern void sqlareceive (int4        reference,
#if ADABAS_VERSION >= 62
			 void      **res_packet_ptr,
			 int4       *res_packet_length,
#else
			 packet     *res_packet,
			 int2       *length,
#endif
			 errtext     errtext,
			 comm_error *returncode);

extern void sqlarelease (int4 reference);

extern void sqlacancel  (int4 reference);

extern void sqltermid (termid terminalid);

/* ----------------------------------------------------------------------- */

extern int  sqlclearuser   (void);
extern void sqlputuser     (xuser_record *user_params,
			    errtext       errtext,
			    boolean      *ok);
extern void sqlgetuser     (xuser_record *user_params,
			    errtext       errtext,
			    boolean      *ok);
extern void sqlindexuser   (int2          user_index,
			    xuser_record  *user_params,
			    errtext       errtext,
			    boolean      *ok);
extern void sqlxuopenuser  (errtext       errtext,
			    boolean      *ok);
extern void sqlxucloseuser (errtext       errtext,
			    boolean      *ok);

/* ----------------------------------------------------------------------- */

extern void sqlarg3 (xuser_record *user_params,
		     SQL_PASSWORD  password,
		     args_options *options,
		     xuser_set     xusertype,
		     c40           errtext,
		     boolean      *ok);

/* ----------------------------------------------------------------------- */

extern void s02applencrypt (name    pw_clear,
			    cryptpw pw_crypt);

extern void s40glint (char      *buf,
		      int4       pos,
		      int        len,
		      int4      *dest,
		      num_error *res);
extern void s40glrel (char      *buf,
		      int4       pos,
		      int        len,
		      double    *dest,
		      num_error *res);

extern void s41plint (char      *buf,
		      int4       pos,
                      int        len,
                      int        frac,
                      int4       source,
		      num_error *res);

extern void s41plrel (char      *buf,
		      int4       pos,
                      int        len,
                      int        frac,
                      double     source,
		      num_error *res);
